> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developers.gappify.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developers.gappify.com/_mcp/server.

# Create a new or update existing Budgets entries.

POST https://api.gappify.com/v1/budgets
Content-Type: application/json

Create a new or update existing Budgets entries with the provided data.

## Required Fields Summary

| Field                    | Type   | Description                                                    |
| ------------------------ | ------ | -------------------------------------------------------------- |
| `source_system_id`       | string | Unique identifier of the budget in the ERP system              |
| `subsidiary_currency_id` | string | Subsidiary currency id of the budget line                      |
| `subsidiary_amount`      | double | Amount of the budget in the subsidiary's base currency         |
| `period`                 | date   | Budget applicable period. ⚠️ **Required format:** `yyyy-mm-01` |

Reference: https://developers.gappify.com/api-reference/inbound-to-gappify/7/post

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Servers

- `https://api.gappify.com/v1` (Production, default)
- `https://api.uat.gappifyinc.com/v1` (UAT)

## Request

### Body (application/json)

This endpoint expects a list of BudgetsPostPayload.

- `list of BudgetsPostPayload`

## Response

### 202

- `request_id` (UUID, required) — Unique identifier for the request
- `status` ("IN_PROGRESS", required) — Status of the request

## Errors

### 401 Unauthorized Error

- `message` (string, required) — The error message
- `success` (boolean, required)

### 422 Unprocessable Entity Error

- `message` (string, required) — The error message
- `errors` (string, required) — The error details

### 404 Not Found Error

- `list of string`

### 500 Internal Server Error

- `list of string`

## Types

### BudgetsPostPayload

- `source_system_id` (string, required) — Unique identifier of the invoice in the erp system. This value will be used to match source data and perform upserts.
- `subsidiary_currency_id` (string, required) — Subsidiary currency id of the budget line. Should match the name in the currency list of source_coas.
- `subsidiary_amount` (double, required) — Amount of the budget in the subsidiarys base currency.
- `period` (date, required) — Budget applicable period. **Format:** `yyyy-mm-01` (e.g., `2026-03-01`).
- `vendor_id` (string, optional) — Id of the Vendor/Supplier. This value should match the source_vendors->g_source_system_id which will be used to send back as part of JE to ERP.
- `subsidiary_id` (string, optional) — Subsidiary id linked to the budget line. This value should match the g_source_system_id in source_coas.
- `department_id` (string, optional) — Department id linked to the budget line. This value should match the g_source_system_id in source_coas.
- `glaccount_number` (string, optional) — GLAccount number
- `glaccount_id` (string, optional) — GLAccount id linked to the budget line. This value should match the g_source_system_id in source_coas.

## Examples

**Request**

```json
[
  {
    "source_system_id": "source_system_id",
    "subsidiary_currency_id": "subsidiary_currency_id",
    "subsidiary_amount": 1.1,
    "period": "2023-01-15"
  },
  {
    "source_system_id": "source_system_id",
    "subsidiary_currency_id": "subsidiary_currency_id",
    "subsidiary_amount": 1.1,
    "period": "2023-01-15"
  }
]
```

**Response**

```json
{
  "request_id": "d5e9c84f-c2b2-4bf4-b4b0-7ffd7a9ffc32",
  "status": "IN_PROGRESS"
}
```

**SDK Code**

```python
import requests

url = "https://api.gappify.com/v1/budgets"

payload = [
    {
        "source_system_id": "source_system_id",
        "subsidiary_currency_id": "subsidiary_currency_id",
        "subsidiary_amount": 1.1,
        "period": "2023-01-15"
    },
    {
        "source_system_id": "source_system_id",
        "subsidiary_currency_id": "subsidiary_currency_id",
        "subsidiary_amount": 1.1,
        "period": "2023-01-15"
    }
]
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.gappify.com/v1/budgets';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '[{"source_system_id":"source_system_id","subsidiary_currency_id":"subsidiary_currency_id","subsidiary_amount":1.1,"period":"2023-01-15"},{"source_system_id":"source_system_id","subsidiary_currency_id":"subsidiary_currency_id","subsidiary_amount":1.1,"period":"2023-01-15"}]'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.gappify.com/v1/budgets"

	payload := strings.NewReader("[\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"subsidiary_amount\": 1.1,\n    \"period\": \"2023-01-15\"\n  },\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"subsidiary_amount\": 1.1,\n    \"period\": \"2023-01-15\"\n  }\n]")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.gappify.com/v1/budgets")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "[\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"subsidiary_amount\": 1.1,\n    \"period\": \"2023-01-15\"\n  },\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"subsidiary_amount\": 1.1,\n    \"period\": \"2023-01-15\"\n  }\n]"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.gappify.com/v1/budgets")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("[\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"subsidiary_amount\": 1.1,\n    \"period\": \"2023-01-15\"\n  },\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"subsidiary_amount\": 1.1,\n    \"period\": \"2023-01-15\"\n  }\n]")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.gappify.com/v1/budgets', [
  'body' => '[
  {
    "source_system_id": "source_system_id",
    "subsidiary_currency_id": "subsidiary_currency_id",
    "subsidiary_amount": 1.1,
    "period": "2023-01-15"
  },
  {
    "source_system_id": "source_system_id",
    "subsidiary_currency_id": "subsidiary_currency_id",
    "subsidiary_amount": 1.1,
    "period": "2023-01-15"
  }
]',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.gappify.com/v1/budgets");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "[\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"subsidiary_amount\": 1.1,\n    \"period\": \"2023-01-15\"\n  },\n  {\n    \"source_system_id\": \"source_system_id\",\n    \"subsidiary_currency_id\": \"subsidiary_currency_id\",\n    \"subsidiary_amount\": 1.1,\n    \"period\": \"2023-01-15\"\n  }\n]", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  [
    "source_system_id": "source_system_id",
    "subsidiary_currency_id": "subsidiary_currency_id",
    "subsidiary_amount": 1.1,
    "period": "2023-01-15"
  ],
  [
    "source_system_id": "source_system_id",
    "subsidiary_currency_id": "subsidiary_currency_id",
    "subsidiary_amount": 1.1,
    "period": "2023-01-15"
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.gappify.com/v1/budgets")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```